Code

Merge branch 'ew/svn-pm'
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
6 # For repeatability, reset the environment to known value.
7 LANG=C
8 LC_ALL=C
9 PAGER=cat
10 TZ=UTC
11 export LANG LC_ALL PAGER TZ
12 EDITOR=:
13 VISUAL=:
14 unset AUTHOR_DATE
15 unset AUTHOR_EMAIL
16 unset AUTHOR_NAME
17 unset COMMIT_AUTHOR_EMAIL
18 unset COMMIT_AUTHOR_NAME
19 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
20 unset GIT_AUTHOR_DATE
21 GIT_AUTHOR_EMAIL=author@example.com
22 GIT_AUTHOR_NAME='A U Thor'
23 unset GIT_COMMITTER_DATE
24 GIT_COMMITTER_EMAIL=committer@example.com
25 GIT_COMMITTER_NAME='C O Mitter'
26 unset GIT_DIFF_OPTS
27 unset GIT_DIR
28 unset GIT_EXTERNAL_DIFF
29 unset GIT_INDEX_FILE
30 unset GIT_OBJECT_DIRECTORY
31 unset SHA1_FILE_DIRECTORIES
32 unset SHA1_FILE_DIRECTORY
33 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
34 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
35 export EDITOR VISUAL
37 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
38         1|2|true)
39                 echo "* warning: Some tests will not work if GIT_TRACE" \
40                         "is set as to trace on STDERR ! *"
41                 echo "* warning: Please set GIT_TRACE to something" \
42                         "other than 1, 2 or true ! *"
43                 ;;
44 esac
46 # Each test should start with something like this, after copyright notices:
47 #
48 # test_description='Description of this test...
49 # This test checks if command xyzzy does the right thing...
50 # '
51 # . ./test-lib.sh
53 error () {
54         echo "* error: $*"
55         trap - exit
56         exit 1
57 }
59 say () {
60         echo "* $*"
61 }
63 test "${test_description}" != "" ||
64 error "Test script did not set test_description."
66 while test "$#" -ne 0
67 do
68         case "$1" in
69         -d|--d|--de|--deb|--debu|--debug)
70                 debug=t; shift ;;
71         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
72                 immediate=t; shift ;;
73         -h|--h|--he|--hel|--help)
74                 echo "$test_description"
75                 exit 0 ;;
76         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
77                 verbose=t; shift ;;
78         --no-python)
79                 # noop now...
80                 shift ;;
81         *)
82                 break ;;
83         esac
84 done
86 exec 5>&1
87 if test "$verbose" = "t"
88 then
89         exec 4>&2 3>&1
90 else
91         exec 4>/dev/null 3>/dev/null
92 fi
94 test_failure=0
95 test_count=0
97 trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
100 # You are not expected to call test_ok_ and test_failure_ directly, use
101 # the text_expect_* functions instead.
103 test_ok_ () {
104         test_count=$(expr "$test_count" + 1)
105         say "  ok $test_count: $@"
108 test_failure_ () {
109         test_count=$(expr "$test_count" + 1)
110         test_failure=$(expr "$test_failure" + 1);
111         say "FAIL $test_count: $1"
112         shift
113         echo "$@" | sed -e 's/^/        /'
114         test "$immediate" = "" || { trap - exit; exit 1; }
118 test_debug () {
119         test "$debug" = "" || eval "$1"
122 test_run_ () {
123         eval >&3 2>&4 "$1"
124         eval_ret="$?"
125         return 0
128 test_expect_failure () {
129         test "$#" = 2 ||
130         error "bug in the test script: not 2 parameters to test-expect-failure"
131         say >&3 "expecting failure: $2"
132         test_run_ "$2"
133         if [ "$?" = 0 -a "$eval_ret" != 0 -a "$eval_ret" -lt 129 ]
134         then
135                 test_ok_ "$1"
136         else
137                 test_failure_ "$@"
138         fi
139         echo >&3 ""
142 test_expect_success () {
143         test "$#" = 2 ||
144         error "bug in the test script: not 2 parameters to test-expect-success"
145         say >&3 "expecting success: $2"
146         test_run_ "$2"
147         if [ "$?" = 0 -a "$eval_ret" = 0 ]
148         then
149                 test_ok_ "$1"
150         else
151                 test_failure_ "$@"
152         fi
153         echo >&3 ""
156 test_expect_code () {
157         test "$#" = 3 ||
158         error "bug in the test script: not 3 parameters to test-expect-code"
159         say >&3 "expecting exit code $1: $3"
160         test_run_ "$3"
161         if [ "$?" = 0 -a "$eval_ret" = "$1" ]
162         then
163                 test_ok_ "$2"
164         else
165                 test_failure_ "$@"
166         fi
167         echo >&3 ""
170 # Most tests can use the created repository, but some amy need to create more.
171 # Usage: test_create_repo <directory>
172 test_create_repo () {
173         test "$#" = 1 ||
174         error "bug in the test script: not 1 parameter to test-create-repo"
175         owd=`pwd`
176         repo="$1"
177         mkdir "$repo"
178         cd "$repo" || error "Cannot setup test environment"
179         "$GIT_EXEC_PATH/git" init-db --template=$GIT_EXEC_PATH/templates/blt/ 2>/dev/null ||
180         error "cannot run git init-db -- have you built things yet?"
181         mv .git/hooks .git/hooks-disabled
182         cd "$owd"
184         
185 test_done () {
186         trap - exit
187         case "$test_failure" in
188         0)
189                 # We could:
190                 # cd .. && rm -fr trash
191                 # but that means we forbid any tests that use their own
192                 # subdirectory from calling test_done without coming back
193                 # to where they started from.
194                 # The Makefile provided will clean this test area so
195                 # we will leave things as they are.
197                 say "passed all $test_count test(s)"
198                 exit 0 ;;
200         *)
201                 say "failed $test_failure among $test_count test(s)"
202                 exit 1 ;;
204         esac
207 # Test the binaries we have just built.  The tests are kept in
208 # t/ subdirectory and are run in trash subdirectory.
209 PATH=$(pwd)/..:$PATH
210 GIT_EXEC_PATH=$(pwd)/..
211 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
212 HOME=$(pwd)/trash
213 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR HOME
215 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
216 export GITPERLLIB
217 test -d ../templates/blt || {
218         error "You haven't built things yet, have you?"
221 # Test repository
222 test=trash
223 rm -fr "$test"
224 test_create_repo $test
225 cd "$test"